<?php
namespace PhpOffice\PhpWord\Writer\HTML_ProseMirror\Element;

use PhpOffice\PhpWord\Element\Chart as ChartElement;
use PhpOffice\PhpWord\Writer\HTML_ProseMirror\Style\Chart as ChartStyleWriter;

/**
 * Chart element HTML writer
 *
 * @since 0.10.0
 */
class Chart extends Text
{
    /**
     * Write image
     *
     * @return string
     */
    public function write()
    {
        if (!$this->element instanceof ChartElement) {
            return '';
        }

        $element = $this->element;
        $styleWriter = new ChartStyleWriter($element->getStyle());
        $style = $styleWriter->write();
        $synoChartId = $this->generateRandomString(10);
        $config = $element->getSynoChartConfig();
        $config = htmlspecialchars(json_encode($config));

        $content = '';
        $content .= $this->writeCommentRangeStart($element);
        $content .= $this->writeRevisionOpeningTag($element);
        $content .= "<span synochart=\"{$synoChartId}\" style=\"{$style}\" contenteditable=\"false\" config=\"{$config}\"></span>";
        $content .= $this->writeRevisionClosingTag($element);
        $content .= $this->writeCommentRangeEnd($element);

        return $content;
    }
}
