<?php
namespace PhpOffice\PhpWord\Writer\HTML_ProseMirror\Element;

use PhpOffice\PhpWord\Element\Object as ObjectElement;

/**
 * Object element HTML writer
 */
class Object extends Text
{
    /**
     * Write object
     *
     * @return string
     */
    public function write()
    {
        global $synoTempPath;

        if (!$this->element instanceof ObjectElement) {
            return '';
        }

        $parentWriter = $this->parentWriter;
        $content = '';

        $synoFileId = $this->generateRandomString(32);
        $synoAlt = $this->element->getFilename();
        $objData = $this->element->getObjectStringData();

        if (empty($objData)) {
            return $content;
        }

        $content .= $this->writeOpening();
        $content .= "<img src=\"\" file-id=\"{$synoFileId}\" alt=\"{$synoAlt}\" file-type=\"binary\"/>";
        $content .= $this->writeClosing();

        // Write attachment to syno temp storage
        $filePath = "{$synoTempPath}{$synoFileId}:{$synoAlt}";
        $fout = fopen($filePath, 'wb', false);
        if ($fout !== false) {
            fwrite($fout, $objData);
            fclose($fout);
        }

        return $content;
    }
}
