<?php
namespace PhpOffice\PhpWord\Writer\HTML_ProseMirror\Element;

/**
 * TextRun element HTML writer
 *
 * @since 0.10.0
 */
class TitleRun extends TextRun
{
    public function writeOpening()
    {
        $pStyle = $this->element->getParagraphStyle()->getFinalStyle();
        if (!$pStyle instanceof \PhpOffice\PhpWord\Style\Paragraph) {
            return;
        }
        $styles = $pStyle->getStyleValues();

        // TODO other styles
        $style = '';
        if ($styles['alignment'] !== null) {
            $style .= "text-align:{$styles['alignment']};";
        }
        if ($styles['color'] !== null) {
            $style .= "color:#{$styles['color']};";
        }
        if ($styles['size'] !== null) {
            $style .= "font-size:{$styles['size']}pt;";
        }

        $content= '';
        if (!$this->withoutP) {
            $content .= "<h{$this->element->getDepth()} synohead=\"{$this->element->getRelationId()}\"";
            if ($style !== '') {
                $content .= " style=\"{$style}\"";
            }
            $content .= ">";
        }

        return $content;
    }

    public function writeClosing()
    {
        $content = '';
        if (!$this->withoutP) {
            $content .= "</h".$this->element->getDepth().">".PHP_EOL;
        }
        return $content;
    }
}
