<?php
namespace PhpOffice\PhpWord\Writer\Word2007\Element;

/**
 * TitleRun element writer
 *
 * @since 0.10.0
 */
class TitleRun extends Text
{
    /**
     * Write textrun element.
     *
     * @return void
     */
    public function write()
    {
        $xmlWriter = $this->getXmlWriter();
        $element = $this->getElement();

        $this->startElementP();

        $bookmarkRId = $element->getPhpWord()->addBookmark();

        // Bookmark start for TOC
        $rId = $element->getRelationId();
        $xmlWriter->startElement('w:bookmarkStart');
        $xmlWriter->writeAttribute('w:id', $bookmarkRId);
        $xmlWriter->writeAttribute('w:name', $rId);
        $xmlWriter->endElement();

        $containerWriter = new Container($xmlWriter, $element);
        $containerWriter->write();

        // Bookmark end for TOC
        $xmlWriter->startElement('w:bookmarkEnd');
        $xmlWriter->writeAttribute('w:id', $bookmarkRId);
        $xmlWriter->endElement();

        $this->endElementP(); // w:p
    }
}
